<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: MAMS (c) 2020-2021 by CMS Made Simple Foundation
#  An add-on module for CMS Made Simple to provide useful functions
#  and commonly used gui capabilities to other modules.
#-------------------------------------------------------------------------
# A fork of:
#
# Module: FrontEndUsers (c) 2008-2014 by Robert Campbell
#         (calguy1000@cmsmadesimple.org)
#
#-------------------------------------------------------------------------
#
# CMSMS - CMS Made Simple is (c) 2006 - 2021 by CMS Made Simple Foundation
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE

namespace MAMS;

class ClearUserHistoryTask implements \CmsRegularTask
{
    public function get_name()
    {
        return get_class();
    }

    public function get_description() {}

    public function test( $time = '')
    {
        if( !$time ) $time = time();
        $mod = \cms_utils::get_module( MOD_MAMS );
        $tmp = (int) $mod->GetPreference('clearhistory_age');
        if( $tmp < 1 ) return;
        $lastrun = (int) $mod->GetPreference('clearhistory_lastrun',0);
        if( $lastrun > time() - 24 * 3600 ) return;

        return TRUE;
    }

    public function execute( $time = '' )
    {
        if( !$time ) $time = time();
        $mod = \cms_utils::get_module( MOD_MAMS );
        $max_age_days = (int) $mod->GetPreference('clearhistory_age');
        // delete everything from the history that is older than $max_age_days

        $older_than = time() - $max_age_days * 24 * 3600;
        \CMSMS\HookManager::do_hook( 'MAMS::ClearUserHistory', $older_than );
        $sql = 'DELETE FROM '.cms_db_prefix().'module_mams_history WHERE refdate < ?';
        $db = $mod->GetDb();
        $db->Execute( $sql, $db->DbTimeStamp( $older_than ) );

        audit('','MAMS','Removed history entries older than '.strftime( '%x %X', $older_than ));
        return TRUE;
    }

    public function on_success($time = '')
    {
        if( !$time ) $time = time();
        $mams = \cms_utils::get_module( MOD_MAMS );
        $mams->SetPreference('clearhistory_lastrun',$time);
    }

    public function on_failure($time = '')
    {
        if( !$time ) $time = time();
    }

} // class
